
{************************************************************************}
{*                                                                      *}
{*                    VB Main Procedures -- Block 2                     *}
{*                                                                      *}
{*        InitLanguage       PrintCopyRight         PrintMainMenu       *}
{*        ChangeLanguage     PrintIntroMenu         DoDirList           *}
{*                                                                      *}
{************************************************************************}


  procedure InitLanguage;
  { initialize language variable }
    var
      LangFile : text;
      i        : integer;
    begin
      if Exist (LangFile,'LANGUAGE.VB')
        then
          readln (LangFile,Language);
      close (LangFile);
      Extent := copy(Language,1,3);
      for i := 1 to 3 do
        Extent[i] := UpCase(Extent[I])
    end;


  procedure PrintCopyright;
  { print the copyright message for VB }
    begin
      PrintPageHeader('');
      writeln;
      center ('Copyright 1985, Norman C. Saunders and Frances M. Coniglio.',TRUE);
      center ('All commercial rights reserved.  This program and it''s     ',TRUE);
      center ('associated data files may be used, copied, or transferred  ',TRUE);
      center ('for non-commercial purposes, without obligation or compen- ',TRUE);
      center ('sation.  They may not be sold or packaged with other soft- ',TRUE);
      center ('ware for sale without the express written consent of the   ',TRUE);
      center ('authors.  Any questions or comments regarding this program ',TRUE);
      center ('should be addressed to:                                    ',TRUE);
      writeln;
      center ('Ms. Frances M. Coniglio or',TRUE);
      center ('Mr. Norman C. Saunders    ',TRUE);
      center ('1225 Martha Custis Drive  ',TRUE);
      center ('Alexandria, VA  22302     ',TRUE);
      pause
    end;


  procedure PrintMainMenu;
  { print main menu and await response }
    begin
      PrintPageHeader('Main Menu');
      writeln;
      center ('I)ntroduction to VOCABULARY BUILDER',TRUE);
      center ('M)ake a new word list              ',TRUE);
      center ('E)dit an existing word list        ',TRUE);
      center ('A)dd to an existing list           ',TRUE);
      center ('D)elete a word list                ',TRUE);
      center ('R)ename a word list                ',TRUE);
      center ('S)tudy                             ',TRUE);
      center ('T)est your mastery                 ',TRUE);
      center ('P)rint a word list                 ',TRUE);
      center ('W)ord list directory               ',TRUE);
      center ('C)hange to another language        ',TRUE);
      center ('Q)uit VOCABULARY BUILDER           ',TRUE);
      writeln;
      ReadResponse(['I','M','E','A','D','R','S','T','P','W','C','Q']);
      case Response of
        'I' : write ('ntroduction');
        'M' : write ('ake a list');
        'E' : write ('dit a list');
        'A' : write ('dd words');
        'D' : write ('elete list');
        'R' : write ('ename list');
        'S' : write ('tudy');
        'T' : write ('est');
        'P' : write ('rint');
        'W' : write ('ord list directory');
        'C' : write ('hange language');
        'Q' : write ('uit');
      end
    end;


  overlay procedure ChangeLanguage;
  { change the language specification }
    var
      i  : integer;
    begin
      PrintPageHeader('Change Language');
      writeln;
      center ('The current language is ' + Language + '.',TRUE);
      writeln;
      center ('Which language do you wish? ',FALSE);
      Readln (Language);
      Language[1] := UpCase(Language[1]);
      Extent := copy(Language,1,3);
      for i := 2 to 3 do
        Extent[i] := UpCase(Extent[i]);
      writeln;
      center ('The language has been changed to ' + Language + '.',FALSE);
      delay(Time)
    end;


  overlay procedure PrintIntroMenu;
  { print introduction menu and await response }
    var
      HelpFile : text;
    begin
      repeat
        PrintPageHeader('Introductory Material');
        writeln;
        center ('W)hat VOCABULARY BUILDER Does      ',TRUE);
        center ('N)aming a Word List                ',TRUE);
        center ('B)uilding a Word List              ',TRUE);
        center ('E)diting a Word List               ',TRUE);
        center ('A)dding Words to a List            ',TRUE);
        center ('S)tudying Word Lists               ',TRUE);
        center ('T)esting for Mastery               ',TRUE);
        center ('H)ints for Using VOCABULARY BUILDER',TRUE);
        center ('V)erb Hints                        ',TRUE);
        center ('R)eturn to Main Menu               ',TRUE);
        writeln;
        ReadResponse(['W','N','B','E','A','S','T','H','V','R']);
        if Response <> 'R'
          then
            begin
              PrintPageHeader('');
              if Exist (HelpFile,'HELP.VB')
                then
                  begin
                    list (UpCase(Response),HelpFile);
                    pause
                  end
                else
                  begin
                    center ('The file HELP.VB is not on the logged drive.',TRUE);
                    pause
                  end
            end;
      until (Response = 'R');
      close (HelpFile)
    end;


  overlay procedure DoDirList;
  { print a directory listing }
    begin
      PrintPageHeader('Word List Directory');
      DirWordList;
      pause
    end;

