
{****************************************************************}
{*                                                              *}
{*                    VB Directory Routines                     *}
{*                                                              *}
{*                    *** CP/M  Version ***                     *}
{*                                                              *}
{****************************************************************}


  procedure DirWordList;
  { derive and print a directory list of word files }

    type
      DirPointer   = ^DirRecord;
      DirRecord    = record
                       DirName  : ListName;
                       Next     : DirPointer;
                     end;

    var
      HeapTop      : ^integer;
      FirstEntry,
      LastEntry,
      NewEntry     : DirPointer;
      FileName     : ListName;
      OK           : boolean;
      DMA          : array[1..128] of byte;
      FCB          : array [1..36] of byte;
      FCB_Address  : integer;
      j            : integer;

      procedure SetFCB;
      { set up file control block for directory search }
        const
          SetDMA_Address = 26;
        var
          DMA_Address    : integer;
          i              : integer;
        begin
          FCB[1] :=  0;
          for i := 2 to 9 do
            FCB[i] := ord('?');
          for i := 1 to 3 do
            FCB[i + 9] := ord(Extent[i]);
          for i := 13 to 36 do
            FCB[i] := 0;
          DMA_Address := addr(DMA);
          FCB_Address := addr(FCB);
          bdos(SetDMA_Address,DMA_Address)
        end;

      procedure GetFirst(var FileName: ListName; var OK: boolean);
      { locate the first directory entry that matches the wildcard }
        const
          SearchForFirst = 17;
        var
          i,j            : integer;
        begin
          i := bdos(SearchForFirst,FCB_Address);
          OK := i <> 255;
          if OK
            then
              begin
                i := i * 32;
                FileName := '';
                for j := 2 to 9 do
                  FileName := FileName + chr(DMA[j + i])
              end
        end;

      procedure GetNext(var FileName: ListName; var OK: boolean);
      { locate the next directory entry that matches the wildcard }
        const
          SearchForNext = 18;
        var
          i,j            : integer;
        begin
          i := bdos(SearchForNext,FCB_Address);
          OK := i <> 255;
          if OK
            then
              begin
                i := i * 32;
                FileName := '';
                for j := 2 to 9 do
                  FileName := FileName + chr(DMA[j + i])
              end
        end;

    begin { DirWordList }
      FirstEntry := nil;
      Mark(HeapTop);
      SetFCB;
      GetFirst(FileName,OK);
      if OK
        then
          begin
            New(NewEntry);
            NewEntry^.DirName := FileName;
            FirstEntry := NewEntry;
            LastEntry := NewEntry;
            LastEntry^.Next := nil;
            repeat
              GetNext(FileName,OK);
              if OK
                then
                  begin
                    New(NewEntry);
                    NewEntry^.DirName := FileName;
                    LastEntry^.Next := NewEntry;
                    LastEntry := NewEntry;
                    LastEntry^.Next := nil
                  end
            until not OK
          end;
      writeln;
      while FirstEntry <> nil do
        begin
          for j := 1 to 20 do
            write (' ');
          write (FirstEntry^.DirName);
          if (8 - length(FirstEntry^.DirName)) > 0
            then
              for j := 1 to (8 - length(FirstEntry^.DirName)) do
                write (' ');
          write ('  |  ');
          FirstEntry := FirstEntry^.Next;
          if FirstEntry <> nil
            then
              begin
                write (FirstEntry^.DirName);
                if (8 - length(FirstEntry^.DirName)) > 0
                  then
                    for j := 1 to (8 - length(FirstEntry^.DirName)) do
                      write (' ');
                write ('  |  ');
                FirstEntry := FirstEntry^.Next;
                if FirstEntry <> nil
                  then
                    begin
                      writeln (FirstEntry^.DirName);
                      FirstEntry := FirstEntry^.Next
                    end
              end
        end;
      writeln;
      Release(HeapTop)
    end;

