
{************************************************************************}
{*                                                                      *}
{*                      VB Directory Routines                           *}
{*                                                                      *}
{*                     *** MS-DOS  version ***                          *}
{*                                                                      *}
{*          SetDTA             FindFirst             FindNext           *}
{*                             DirWordList                              *}
{*                                                                      *}
{************************************************************************}



const
   Carry     = 1;

type
   DirRec    = record
                 Filler    : array[1..30] Of byte;
                 FName     : array[1..10] Of char;
               end;
   DOSRegs   = record
                 Ax, Bx, Cx, Dx, Bp, Si, Di, Ds, Es, Flags : integer;
               end;


  procedure SetDTA(var DMAbuf);
  { set the data transfer area address }
    var
      DirReg    : DOSregs;
    begin
      DirReg.Ax := $1A00;
      DirReg.Ds := SEG(DMAbuf);
      DirReg.Dx := OFS(DMAbuf);
      MsDos(DirReg);
    end;


  function FindFirst(Pattern: AnyString; var First: DirRec): integer;
  { search for first file match }
    var
      DirReg    : DOSRegs;
    begin
      SetDTA(First);
      Pattern := Pattern + chr(0);
      DirReg.Ds := SEG(Pattern[1]);
      DirReg.Dx := OFS(Pattern[1]);
      DirReg.Ax := $4E00;
      DirReg.Cx := $FF;
      MsDos(DirReg);
      if (Carry and DirReg.Flags ) = 0
        then
          FindFirst := 0
        else
          FindFirst := DirReg.Ax;
    end;


  function FindNext(var Next: DirRec) : integer;
  { search for subsequent file matches }
    var
      DirReg : DOSRegs;
    begin
      SetDTA(Next);
      DirReg.Ax := $4F00;
      MsDos(DirReg);
      if (Carry and DirReg.Flags ) = 0
        then
          FindNext := 0
        else
          FindNext := DirReg.Ax;
    end;


  procedure DirWordList;
  { derive and print a directory of word list files }
    var
      DirNames        : array[1..50] of ListName;
      Mask            : AnyString;
      FileName        : DirRec;
      FileCount       : integer;
      i, j, Iok       : integer;

    procedure Transfer(F: DirRec);
    { transfer a file name char array to a string }
      var
        DirName : string[9];
        k       : integer;
      begin
        k := 1;
        while (F.FName[k] <> '.') and (k <= 9) do
          begin
            DirName[k] := F.FName[k];
            k := succ(k)
          end;
        DirName[0] := chr(k-1);
        DirNames[FileCount] := copy(DirName,1,length(DirName))
      end;

    begin { DirWordList }
      Mask := '????????.' + Extent;
      FileCount := 0;
      Iok := FindFirst(Mask,FileName);
      if Iok = 0
        then
          begin
            FileCount := succ(FileCount);
            Transfer(FileName)
          end;
      while Iok = 0 do
        begin
          Iok := FindNext(FileName);
          if Iok = 0
            then
              begin
                FileCount := succ(FileCount);
                Transfer(FileName)
              end
        end;
      i := 1;
      writeln;
      repeat
        for j := 1 to 20 do
          write (' ');
        write (DirNames[i]);
        if (8 - length(DirNames[i]))  > 0
          then
            for j := 1 to (8 - length(Dirnames[i])) do
              write (' ');
        write ('  |  ');
        i := succ(i);
        if i <= FileCount
          then
            begin
              write (DirNames[i]);
              if (8 - length(DirNames[i])) > 0
                then
                  for j := 1 to (8 - length(Dirnames[i])) do
                    write (' ');
              write ('  |  ')
            end;
        i := succ(i);
        if i <= FileCount
          then
            writeln (DirNames[i]);
        i := succ(i)
      until i > FileCount;
      writeln
    end;

